image: python:3.10.6

variables:
  PROJECTNAME: $CI_PROJECT_NAME

stages:
    - test
    - release

test:
    stage: test
    cache: {}
    script:
        - pip install -U -r requirements.txt
        - pip install -U coverage
        - python -m coverage run -m unittest discover -s tests -p "test_*.py"
        - python -m coverage report --data-file=.coverage
        - python -m coverage xml --data-file=.coverage -o cov/coverage.xml
        - python -m coverage html --data-file=.coverage -d cov/htmlcov
    only:
        - pushes
    coverage: '/TOTAL.*\s+(\d+\%)/'
    artifacts:
        paths:
        - :./cov/
        reports:
            coverage_report:
                coverage_format: cobertura
                path: cov/coverage.xml
pypi:
    stage: release
    cache: {}
    variables:
        APP_VERSION: $CI_COMMIT_TAG
    script:
        - sed -i "s/v0.0.0/${APP_VERSION}/g" setup.py
        - pip install -U -r requirements.txt
        - pip install -U twine
        - python setup.py sdist
        - twine upload dist/*
    rules:
        - if: '$CI_COMMIT_TAG =~ /^v\d+\.\d+(\.\d+)?(-\S*)?$/'
